//+------------------------------------------------------------------+
//|                                                       MAonMA.mq4 |
//|                                                 Copyright  2012 |
//|                                             basisforex@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012"
#property link      "basisforex@gmail.com"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 Blue
#property indicator_color2 Aqua
#property indicator_color3 Yellow
#property indicator_color4 LimeGreen
#property indicator_color5 DeepPink
//
extern int maPeriod_1   = 13;
extern int maMethod_1   = 0;
extern int maAppPrice_1 = 0;
extern int maPeriod_2   = 34;
extern int maMethod_2   = 0;
extern int maPeriod_3   = 89;
extern int maMethod_3   = 0;

extern string note             = "turn on Alert = true; turn off = false";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = true;
extern bool   alertsEmail      = false;
extern string soundfile        = "alert2.wav";

extern int    arrowthickness   = 1;

//---- indicator buffers
double a[]; 
double b[]; 
double c[];
double CrossUp[];
double CrossDn[];
double trend[];
//+------------------------------------------------------------------+
int init()
 {
   IndicatorBuffers(6);  
   SetIndexBuffer(0,a);
   SetIndexBuffer(1,b);
   SetIndexBuffer(2,c);
   SetIndexBuffer(3,CrossUp);  SetIndexStyle(3,DRAW_ARROW,0,arrowthickness); SetIndexArrow(3,233);
   SetIndexBuffer(4,CrossDn);  SetIndexStyle(4,DRAW_ARROW,0,arrowthickness); SetIndexArrow(4,234);
   SetIndexBuffer(5,trend);
   
   return(0);
 }
//+------------------------------------------------------------------+
int start()
{
   int    limit, i; 
   int    counted_bars=IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMax(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
   
   for (i=limit; i>=0; i--)  a[i] = iMA(NULL, 0, maPeriod_1 , 0, maMethod_1, maAppPrice_1, i);
   for (i=limit; i>=0; i--)  b[i] = iMAOnArray(a, Bars, maPeriod_2, 0, maMethod_2, i);
   for (i=limit; i>=0; i--) 
   {
      c[i] = iMAOnArray(b, Bars, maPeriod_3, 0, maMethod_3, i);
      trend[i] = trend[i+1];
          if (a[i]>c[i]) trend[i] = 1;
          if (a[i]<c[i]) trend[i] =-1;
          
          //
          //
          //
          //
          //
      
          CrossUp[i] = EMPTY_VALUE;
          CrossDn[i] = EMPTY_VALUE;
          if (trend[i]!= trend[i+1])
          if (trend[i] == 1)
                CrossUp[i] = c[i] - iATR(NULL,0,20,i)/2;
          else  CrossDn[i] = c[i] + iATR(NULL,0,20,i)/2;
          }
          
          //
          //
          //
          //
          //
      
          if (alertsOn)
          {
          if (alertsOnCurrent)
               int whichBar = 0;
          else     whichBar = 1;
         
          if (trend[whichBar] != trend[whichBar+1])
          if (trend[whichBar] == 1)
                doAlert("Buy");
          else  doAlert("Sell");       
   }

return(0);
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ma on ma cross ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," ma on ma cross "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}


   
//+------------------------------------------------------------------+

